
// POSTPROCESS GAUSS
//Texture2D postProc : RT_CONST_GAUSSIAN;
Texture2D sceneTex : RT_CONST_SCENE;
float dHor : SAMPLEHORIZONTAL;
float dVer : SAMPLEVERTICAL;

SamplerState simpleSampler : SAMPLER
{
    Filter = MIN_MAG_MIP_LINEAR;
    AddressU = Wrap;
    AddressV = Wrap;
};

struct QuadStruct
{

	float4 vPos : SV_POSITION;
	float2 tCoord : NORMAL;
};

QuadStruct PostProcessing_VS ( float4 Pos : POSITION, float2 tC : TEXCOORD )
{

	QuadStruct output;
	output.vPos = Pos;
	output.tCoord = tC;
	
	return output;
}

// DEBUGSHADER FOR DEFERRED SHADING
float4 PostProcessing_PS ( QuadStruct quadSrc ) : SV_Target
{

	float4 finalColor = float4( 0, 0, 0, 0 );
	finalColor += 9 * sceneTex.Sample( simpleSampler, quadSrc.tCoord );
	finalColor += 5 * sceneTex.Sample( simpleSampler, quadSrc.tCoord + float2( 0, dVer ) );
	finalColor += 5 * sceneTex.Sample( simpleSampler, quadSrc.tCoord - float2( 0, dVer ) );
	finalColor += 5 * sceneTex.Sample( simpleSampler, quadSrc.tCoord + float2( dHor, 0 ) );
	finalColor += 5 * sceneTex.Sample( simpleSampler, quadSrc.tCoord - float2( dHor, 0 ) );
	finalColor += 3 * sceneTex.Sample( simpleSampler, quadSrc.tCoord + float2( dHor, dVer ) );
	finalColor += 3 * sceneTex.Sample( simpleSampler, quadSrc.tCoord - float2( dHor, dVer ) );
	finalColor += 3 * sceneTex.Sample( simpleSampler, quadSrc.tCoord + float2( dHor, -dVer ) );
	finalColor += 3 * sceneTex.Sample( simpleSampler, quadSrc.tCoord - float2( dHor, -dVer ) );
	finalColor += 2 * sceneTex.Sample( simpleSampler, quadSrc.tCoord + 2 * float2( 0, dVer ) );
	finalColor += 2 * sceneTex.Sample( simpleSampler, quadSrc.tCoord - 2 * float2( 0, dVer ) );
	finalColor += 2 * sceneTex.Sample( simpleSampler, quadSrc.tCoord + 2 * float2( dHor, 0 ) );
	finalColor += 2 * sceneTex.Sample( simpleSampler, quadSrc.tCoord - 2 * float2( dHor, 0 ) );
	finalColor += sceneTex.Sample( simpleSampler, quadSrc.tCoord + float2( 2 * dHor, dVer ) );
	finalColor += sceneTex.Sample( simpleSampler, quadSrc.tCoord - float2( 2 * dHor, dVer ) );
	finalColor += sceneTex.Sample( simpleSampler, quadSrc.tCoord + float2( 2 * dHor, - dVer ) );
	finalColor += sceneTex.Sample( simpleSampler, quadSrc.tCoord - float2( 2 * dHor, -dVer ) );
	finalColor += sceneTex.Sample( simpleSampler, quadSrc.tCoord + float2( dHor, 2 * dVer ) );
	finalColor += sceneTex.Sample( simpleSampler, quadSrc.tCoord - float2( dHor, 2 * dVer ) );
	finalColor += sceneTex.Sample( simpleSampler, quadSrc.tCoord + float2( dHor, 2 * -dVer ) );
	finalColor += sceneTex.Sample( simpleSampler, quadSrc.tCoord - float2( dHor, 2 * -dVer ) );
	
	finalColor /= 57.0f;
	
	return finalColor;
}

technique10 DefaultPostProcessing
{

    pass P0
    {
    
		SetVertexShader( CompileShader( vs_4_0, PostProcessing_VS() ) );
		SetGeometryShader( NULL );
		SetPixelShader( CompileShader( ps_4_0, PostProcessing_PS() ) );
    }
}
