
matrix viewMat : VIEWMATRIX;
matrix projection : WORLDVIEWPROJMATRIX;

struct VARYING
{

	float4 vPos : SV_POSITION;
    float3 Norm : NORMAL;
};

void SimpleRefraction_VS ( float4 Pos : POSITION, float3 Norm : NORMAL, out VARYING vs_output )
{

    vs_output.vPos = mul( Pos, projection );
    vs_output.Norm = mul( -Norm, (float3x3)viewMat );
}

void SimpleRefraction_PS ( in VARYING ps_input, out float3 normals : SV_Target0 )
{

	normals = normalize( ps_input.Norm ) / 2.0f + float3( 0.5f, 0.5f, 0.5f );
}

technique10 SimpleRefraction
{
    pass P0
    {
        SetVertexShader( CompileShader( vs_4_0, SimpleRefraction_VS() ) );
        SetGeometryShader( NULL );
        SetPixelShader( CompileShader( ps_4_0, SimpleRefraction_PS() ) );
    }
}